#include <vector>
#include <iostream>
#include <unordered_map>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

struct edge {
    int end;
    int weight;
};

vector<edge> edges = {};

int N, M;
unordered_map<int, vector<int>> graph = {};

vector<int> q = {};
unordered_map<int, int> distances = {};
vector<int> explored = {};

void print_q() {
    for (auto e: q) {
        cout << "(" << edges[e].end << ", " << edges[e].weight << ")" << ", ";
    }
    cout << endl;
}

void print_explored() {
    cout << "Explored: ";
    for (auto e: explored) {
        cout << e << ", ";
    }
    cout << endl;
}

void dijkstra() {
    if (q.size() == 0) {
        return;
    }

    edge c = edges[q.front()];
    int c_id = c.end;

    q.erase(q.begin());

    if (c.weight < distances[c.end]) {
        distances[c.end] = c.weight;
    }

    explored.push_back(c_id);

    print_explored();
    cout << "Fetching: ";
    for (int e: graph[c.end]) {
        cout << e << ", ";
    }
    cout << endl;

    for (int e: graph[c.end]) {
        bool flag = false;

        for (int k: explored) {
            if (edges[k].end == c.end && edges[k].weight >= c.weight) {
                flag = true;
                goto go_next;
            }
        }

        go_next:
        if (flag) {
            cout << "Backtracking" << endl;
            continue;
        }

        edge next = {edges[e].end, edges[e].weight + c.weight};
        edges.push_back(next);


        q.push_back(edges.size() - 1);
        print_q();
    }

    dijkstra();
}

int main() {
    cin >> N >> M;

    int u, l, r;

    for (int i = 0; i < M; i++) {
        cin >> u >> l >> r;

        for (int v = l; v <= r; v++) {
            edges.push_back({v, v-l+1});
            graph[u].push_back(edges.size() - 1);
        }
    }

    for (int i = 1; i <= N; i++) {
        distances[i] = 2000000000;
        for (int j = 0; j < graph[i].size(); j++) {
            cout << i << " -> " << edges[graph[i][j]].end << ", w = " << edges[graph[i][j]].weight << endl;
        }
    }

    edges.push_back({1, 0});
    q.push_back(edges.size() - 1);
    dijkstra();


    return 0;
}
