#include <bits/stdc++.h>
#define endl '\n'
#define loop(x) for(int loop = 0; loop<x; loop++)
#define print(x) cout<<x
#define llint long long int
using namespace std;
void speed()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
struct Edge
{
    int u;
    int v;
    int w;
    Edge(int _u, int _v, int _w)
    {
        u = _u;
        v = _v;
        w = _w;
    }
};
struct Graph
{
    bool one_connected[(int)1e5];
    vector<int> index[(int)1e5];
    vector<Edge> edges;
    array<int, (int)1e5> shortest;
}graph;
void update(Graph &graph, int u, int l, int r)
{
    for(int v = l; v<=r; v++)
    {
        graph.edges.push_back(Edge(u,v,(v-l+1)));
        graph.index[v].push_back(graph.edges.size()-1);
        if(graph.one_connected[u])
        {
            graph.one_connected[v] = true;
        }

    }
}
int shortest_path(Graph &graph, int v, bool found = false)
{
    if(v == 1) return 0;
    if(found) return graph.shortest[v];
    int min_w = 1e5;
    int current = 0;
    for(int idx : graph.index[v])
    {
        current = graph.edges[idx].w + shortest_path(graph, graph.edges[idx].u, graph.shortest[graph.edges[idx].u] > 0);
        min_w = min(min_w, current);
    }
    graph.shortest[v] = min_w;
    return min_w;
}
void debug(int n)
{
    for(Edge e : graph.edges)
    {
        print(e.u)<<", ";
        print(e.v)<<", ";
        print(e.w)<<endl;
    }
    for(int i = 0; i<=n; i++)
    {
        print(graph.one_connected[i])<<endl;
    }
    for(int i = 0; i<n; i++)
    {
        print(i)<<": ";
        for(int v : graph.index[i])
        {
            print(v)<<", ";
        }
        print(endl);
    }
}
int main ()
{
    speed();
    int n,m;
    cin>>n>>m;
    int u,r,l;
    graph.one_connected[1] = true;
    graph.shortest.fill(0);
    loop(m)
    {
        cin>>u>>l>>r;
        update(graph,u,l,r);
    }
    //debug(n);
    print(0)<<" ";
    for(int i = 2; i<=n; i++)
    {
        if(!graph.one_connected[i])
        {
            print(-1)<<" ";
        }
        else
        {
            print(shortest_path(graph, i))<<" ";
        }
    }
    return 0;
}
