#include <iostream>
#include <vector>
#include <array>
#include <climits>
#include <queue>

using namespace std;

int n, m;

struct Path
{
    int target;
    int dist;
};

int** dp;

void traverse(int start, vector<bool>& visited)
{
    int curr = start;

    visited[curr]=true;
    queue<int> q;
    q.push(curr);

    while(!q.empty())
    {
        curr = q.front();
        q.pop();
        visited[curr]=true;

        //cout<<curr<<"\n";

        for(int i = 1; i<=n; ++i)
        {
            if(dp[curr][i]!=INT_MAX && !visited[i])
            {
                q.push(i);
                //cout<<curr<<" -> "<<i<<": "<<dp[start][i]<<"  "<<dp[start][curr]+dp[curr][i]<<"\n";
                if(dp[start][i]>dp[start][curr]+dp[curr][i])
                {
                    dp[start][i]=dp[start][curr]+dp[curr][i];
                }
            }
        }
    }

    //cout<<"\n";

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    vector<int> u(m+1);
    vector<int> l(m+1);
    vector<int> r(m+1);

    dp = new int*[n+1];
    for(int i = 0; i<n+1; ++i)
    {
        dp[i] = new int[n+1];
    }
    for(int i = 0; i<n+1; ++i)
    {
        for(int j = 0; j<n+1; ++j)
        {
            if(i==j)
            {
                dp[i][j]=0;
                continue;
            }
            dp[i][j]=INT_MAX;
        }
    }
    vector<bool> visited(n+1, false);

    int in_u, in_l, in_r;

    for(int i = 1; i<=m; ++i)
    {
        cin>>in_u>>in_l>>in_r;
        u[i]=in_u;
        l[i]=in_l;
        r[i]=in_r;
    }

    for(int i = 1; i<=m; ++i)
    {
        for(int j = l[i]; j<=r[i]; ++j)
        {
            if(dp[u[i]][j]>j-l[i]+1)
                dp[u[i]][j] = j-l[i]+1;
        }
    }

    traverse(1, visited);


    for(int i = 1; i<=n; ++i)
    {
        if(dp[1][i]==INT_MAX)
        {
            cout<<"-1 ";
            continue;
        }
        cout<<dp[1][i]<<" ";
    }
}
