#include<bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

const int MAXN=2e5+5;
const int INF=1e18+5;

int n,m;

struct SegmentTree
{
    int tree[4*MAXN];

    void init()
    {
        fill(tree+1,tree+4*n+1,INF);
    }

    void update(int node,int l,int r,int ql,int qr,int val)
    {
        if(ql<=l && r<=qr)
        {
            tree[node]=min(tree[node],val+l-ql+1);
            return;
        }
        int mid=(l+r)/2;
        if(ql<=mid) update(2*node,l,mid,ql,qr,val);
        if(mid<qr) update(2*node+1,mid+1,r,ql,qr,val);
    }

    int query(int node,int l,int r,int pos,int ans)
    {
        ans=min(ans, tree[node]+pos-l);
        if(l==r) return ans;
        int mid=(l+r)/2;
        if(pos<=mid) return query(2*node,l,mid,pos,ans);
        else return query(2*node+1,mid+1,r,pos,ans);
    }

    void update(int l,int r,int val)
    {
        return update(1,1,n,l,r,val);
    }

    int query(int pos)
    {
        return query(1,1,n,pos,INF);
    }
};

SegmentTree tree;
vector<pair<int,int> > adj[MAXN];
priority_queue<pair<int,pair<int,int> > > pq;
int d[MAXN];
bool used[MAXN];
set<int> avb;

void use(int v)
{
    if(!used[v]) avb.erase(v);
    used[v]=1;
}

int getFirst(pair<int,int> intr)
{
    auto it=avb.lower_bound(intr.first);
    if(it==avb.end()) return n+1;
    return (*it);
}

void dijkstra()
{
    for(int i=1;i<=n;i++) d[i]=INF;
    d[1]=0;
    tree.update(1,1,-1);
    //cout<<tree.query(1)<<endl;
    pq.push({0,{1,1}});
    while(!pq.empty())
    {
        auto [w,intr]=pq.top();
        pq.pop();
        int v=getFirst(intr);
        if(v>intr.second) continue;
        //if(used[v]) continue;
        use(v);
        if(v<intr.second) pq.push({w-(v-intr.first+1),{v+1,intr.second}});
        int dist=d[v]=tree.query(v);
        //cout<<v<<": "<<endl;
        for(auto [l,r]: adj[v])
        {
            int u=getFirst({l,r});
            if(u>r) continue;
            //d[u]=tree.query(u);
            tree.update(l,r,dist);
            //cout<<l<<" "<<r<<" "<<u<<endl;
                pq.push({-(dist+u-l+1),{u,r}});
            /*if(dist+u-l+1<d[u])
            {
                d[u]=dist+u-l+1;
            }*/
        }
        //for(int i=1;i<=n;i++) cout<<tree.query(i)<<" "; cout<<endl;
    }
}

signed main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;
for(int i=0;i<m;i++)
{
    int u,l,r;
    cin>>u>>l>>r;
    adj[u].push_back({l,r});
}

tree.init();
for(int i=1;i<=n;i++) avb.insert(i);
dijkstra();

for(int i=1;i<=n;i++)
{
    int dist=tree.query(i);
    if(dist>=INF) cout<<-1<<" ";
    else cout<<dist<<" ";
}
cout<<endl;

return 0;
}
