#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const int B=750;

int n,k;

struct Fenwick
{
    int tree[MAXN];

    void init()
    {
        fill(tree,tree+n+1,0);
    }

    void update(int idx,int val)
    {
        for(;idx<=n;idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }

    int query(int idx)
    {
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }
};

Fenwick tree;
int a[MAXN];
int b[MAXN];
pair<int,int> c[MAXN];
int pos[MAXN];
long long pref[MAXN];
set<pair<int,int> > s;
vector<long long> ans;

void rebuild(int m)
{
    for(int i=1;i<=m;i++) c[i]={a[i],i};
    sort(c+1,c+m+1);
    for(int i=1;i<=m;i++)
    {
        b[i]=c[i].fi;
        pos[c[i].se]=i;
    }
    s.clear();
    s.insert({1,m});
    for(int i=1;i<=m;i++)
    {
        pref[i]=((i-k>0) ? pref[i-k] : 0LL)+b[i]; ///
    }
    for(int i=0;i<=m;i++) tree.tree[i]=0;
}

long long calc(pair<int,int> cur)
{
    int l=cur.fi-tree.query(cur.fi);
    l%=k;
    int st=cur.fi;
    if(l!=1)
    {
        if(l==0) l=1;
        else l=k+1-l;
        st=cur.fi+l;
    }
    long long ret=0;
    //cout<<cur.fi<<" "<<cur.se<<" "<<l<<" "<<st<<endl;
    if(st>cur.se) return 0;
    int fn=st+((cur.se-st)/k)*k;
    return pref[fn]-((st-k>0) ? pref[st-k] : 0); ///
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=1;i<=n;i++) cin>>a[i];

rebuild(n);
ans.push_back(calc((*s.begin())));//cout<<ans.back()<<endl;
for(int i=n;i>1;i--)
{
    //cout<<i<<endl;
    //for(auto r: s) cout<<r.fi<<","<<r.se<<" "; cout<<endl;

    long long tmp=ans.back();
    auto it=s.upper_bound({pos[i],n+1}); it--;
    auto cur=(*it);
    for(auto it1=it;it1!=s.end();it1++)
    {
        tmp-=calc((*it1));
    }
    s.erase(it);

    tree.update(pos[i],1);

    if(cur.fi<pos[i])
    {
        s.insert({cur.fi,pos[i]-1});
        tmp+=calc({cur.fi,pos[i]-1});
    }
    if(pos[i]<cur.se)
    {
        s.insert({pos[i]+1,cur.se});
        tmp+=calc({pos[i]+1,cur.se});
    }

    auto it2=s.lower_bound({cur.se+1,0});
    for(auto it3=it2;it3!=s.end();it3++)
    {
        tmp+=calc((*it3));
    }
    ans.push_back(tmp);

    //for(auto r: s) cout<<r.fi<<","<<r.se<<" "; cout<<endl;

    if(s.size()>B && i>2) rebuild(i-1);
}

while(!ans.empty())
{
    cout<<ans.back()<<endl;
    ans.pop_back();
}

return 0;
}
