#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int n, m;
const int MAXN = 100000 + 2;
struct Node
{
    int v, tg;
    Node () {}
    Node (int _v, int _tg)
    {
        v = _v;
        tg = _tg;
    }
};

long long best[10005][10005];

vector <Node> G[MAXN];
bool used[MAXN];
int d[MAXN];

bool operator < (Node a, Node b)
{
    return a.tg > b.tg;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i != j) best[i][j] = 2e9;
        }
    }

    for (int i = 1; i <= m; i++)
    {
        int u, l, r;
        cin >> u >> l >> r;
        for (int v = l; v <= r; v++)
        {
            long long w = v - l + 1;
            best[u][v] = min(w, best[u][v]);
        }
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (best[i][j] && best[i][j] < 2e9)
            {
                G[i].push_back(Node(j, best[i][j]));
            }
        }
    }

    priority_queue <Node> pq;
    pq.push(Node(1, 0));

    for (int i = 2; i <= n; i++)
        d[i] = 2e9;

    while (!pq.empty())
    {
        int v = pq.top().v;
        int tg = pq.top().tg;
        pq.pop();

        if (used[v]) continue;
        used[v] = 1;

        for (auto &x: G[v])
        {
            if (d[v] + x.tg < d[x.v])
            {
                d[x.v] = d[v] + x.tg;
                pq.push(Node(x.v, d[v] + x.tg));
            }
        }
    }

    for (int i = 1; i <= n; i++)
    {
        cout << (d[i] != 2e9 ? d[i] : -1) << " ";
    }
    cout << endl;

    return 0;
}
/**
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4

0 2 3 4 -1 -1 1 1 2 -1

*/

