#include <iostream>
#include <vector>
#include <queue>
using namespace std;

struct edge{
    int v, w;
    edge(){}
    edge(int _v, int _w){
        v = _v;
        w = _w;
    }
};

vector<int> dist;
int n, m;
vector<edge> v[200100];

void read(){
    cin >> n >> m;

    for(int i = 0; i < m; i ++){
        int u, l, r;
        cin >> u >> l >> r;

        for(int j = l; j <= r; j++){
            if(j == u) v[u].push_back({j, 0});
            else v[u].push_back({j, j-l+1});
        }
    }
}

void dijkstra(int beg){
    priority_queue<pair<int, int>> pq;
    dist.resize(n+1, 1e9);
    pq.push({0, beg});

    while(!pq.empty()){
        int weight = pq.top().first;
        int node = pq.top().second;
        pq.pop();

        for(int i = 0; i < v[node].size(); i++){
            if(v[node][i].w + weight < dist[v[node][i].v]){
                dist[v[node][i].v] = v[node][i].w + weight;
                pq.push({dist[v[node][i].v], v[node][i].v});
            }
        }
    }
}

int main(){
    read();
    dijkstra(1);
    for(int i = 1; i <= n; i++){
        if(dist[i] == 1e9){
            if(i == n) cout << -1;
            else cout << -1 << ' ';
        } else {
            if(i == n) cout << dist[i];
            else cout << dist[i] << ' ';
        }
    }
    return 0;
}
