#include<bits/stdc++.h>

#define MAXN 100001

using namespace std;

int n, m, dist[MAXN];
struct MyHash
{
    size_t operator()(pair<int, int> const& p) const noexcept
    {
        return p.first ^ (p.second << 1);
    }
};
unordered_map<pair<int, int>, int, MyHash> adj;
vector<pair<int, int> > M[MAXN];
priority_queue<pair<int, int> > pq;
bool vis[MAXN];

void add_edges(int v, int l, int r)
{
    int w = 1;
    for(int i = l; i <= r; i ++)
    {
        if(!adj[{v, i}] || w < adj[{v, i}]) adj[{v, i}] = w;
        w ++;
    }
}
void dijkstra(int v)
{
    pq.push({0, v});
    dist[1] = 0;
    while(pq.size())
    {
        pair<int, int> tp = pq.top();
        int v = tp.second;
        int d = -tp.first;
        //cout<<v<<" -> "<<d<<endl;
        pq.pop();
        if(vis[v]) continue;
        vis[v] = 1;
        for(int i = 1; i <= n; i ++)
        {
            if(!adj[{v, i}]) continue;
            int to = i;
            int w = adj[{v, i}];
            if(dist[to] > d + w)
            {
                dist[to] = d + w;
                pq.push({-dist[to], to});
            }
        }
    }
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i = 0; i < m; i ++)
    {
        int v, l, r;
        cin>>v>>l>>r;
        add_edges(v, l, r);
    }
}
void print()
{
    for(int i = 1; i <= n; i ++)
    {
        if(dist[i] == 1e9) cout<<-1<<' ';
        else cout<<dist[i]<<' ';
    }
    cout<<endl;
}
int main()
{
    read();
    fill_n(dist, n + 1, 1e9);
    dijkstra(1);
    print();
    return 0;
}
