#include<bits/stdc++.h>

#define MAXN 100001

using namespace std;

int n, m, dist[MAXN];
vector<pair<int, int> > M[MAXN];
unordered_map<int, vector<int>> adj;
priority_queue<pair<int, int> > pq;
bool vis[MAXN];

struct query
{
    int v, l, r;
    bool operator< (query other)
    {
        return v < other.v;
    }
}queries[MAXN];
void add_edges(int v, int l, int r)
{
    int w = 1;
    if(adj[v].empty())
    {
        vector<int> cc;
        cc.resize(n + 1);
        adj[v] = cc;
    }
    for(int i = l; i <= r; i ++)
    {
        if(!adj[v][i] || w < adj[v][i]) adj[v][i] = w;
        w ++;
    }
}
void dijkstra(int v)
{
    pq.push({0, v});
    dist[1] = 0;
    while(pq.size())
    {
        pair<int, int> tp = pq.top();
        int v = tp.second;
        int d = -tp.first;
        //cout<<v<<" -> "<<d<<endl;
        pq.pop();
        if(vis[v]) continue;
        vis[v] = 1;
        for(int i = 1; i <= n; i ++)
        {
            //cout<<v<<"   "<<i<<endl;
            if(adj[v].empty() || !adj[v][i]) continue;
            int to = i;
            int w = adj[v][i];
            if(dist[to] > d + w)
            {
                dist[to] = d + w;
                pq.push({-dist[to], to});
            }
        }
    }
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i = 0; i < m; i ++)
    {
        int v, l, r;
        cin>>v>>l>>r;
        add_edges(v, l, r);
    }
}
void print()
{
    cout<<0<<' ';
    for(int i = 2; i <= n; i ++)
    {
        /*if(dist[i] == 1e9)*/ cout<<-1<<' ';
        /*else cout<<dist[i]<<' ';*/
    }
    cout<<endl;
}
int main()
{
    read();
    fill_n(dist, n + 1, 1e9);
    dijkstra(1);
    print();
    return 0;
}
