#include<iostream>
#include<vector>
#include<algorithm>
#define MAXN 100010
using namespace std;
long long tree[4*MAXN][2];
int qu[MAXN],a[MAXN];
vector<pair<int,int>> order;
void flip(int ind, int l, int r, int ql, int qr)
{
    if(qr<l || r<ql)return;
    if(l==r){swap(tree[ind][0],tree[ind][1]);return;}

    int mid=(l+r)>>1;
    int left=(ind<<1),right=left|1;

    flip(left,l,mid,ql,qr);
    flip(right,mid+1,r,ql,qr);

    tree[ind][0]=tree[left][0]+tree[right][0];
    tree[ind][1]=tree[left][1]+tree[right][1];
}
void update(int ind, int l, int r, int pos, int val, bool t)
{
    if(l==r){tree[ind][t]=val;return;}

    int mid=(l+r)>>1;
    int left=(ind<<1),right=left|1;

    if(pos<=mid)update(left,l,mid,pos,val,t);
    else update(right,mid+1,r,pos,val,t);

    tree[ind][0]=tree[left][0]+tree[right][0];
    tree[ind][1]=tree[left][1]+tree[right][1];
}
long long query(int ind, int l, int r, int ql, int qr, bool t)
{
    if(qr<l || r<ql)return 0;
    if(ql<=l && r<=qr)return tree[ind][t];

    int mid=(l+r)>>1;
    int left=(ind<<1),right=left|1;

    return query(left,l,mid,ql,qr,t)+query(right,mid+1,r,ql,qr,t);
}
int fen[MAXN];
void fenup(int ind, int val)
{
    for(;ind<=MAXN;ind+=(ind & -ind))fen[ind]+=val;
}
int fenq(int ind)
{
    int res=0;
    for(;ind>0;ind-=(ind & -ind))res+=fen[ind];
    return res;
}
void print(int ind, int l, int r)
{
    cout<<l<<" "<<r<<": "<<tree[ind][1]<<"\n";
    if(l==r)return;
    int mid=(l+r)>>1;
    int left=(ind<<1),right=left|1;
    print(left,l,mid);
    print(right,mid+1,r);
}
int main()
{
    int n,k;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        order.push_back({a[i],i});
    }
    sort(order.begin(),order.end());
    for(int i=0;i<order.size();i++)
    {
        qu[order[i].second]=i+1;
    }
    for(int i=1;i<=n;i++)
    {
        bool t=((fenq(qu[i])+1)&1);

        flip(1,1,n,qu[i]+1,n);
        update(1,1,n,qu[i],a[i],t);
        fenup(qu[i],1);

        cout<<query(1,1,n,1,n,1)<<"\n";
    }
}