//it is your desire to work hard

#include<bits/stdc++.h>
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef complex<double> C;

const int maxn=1e5+3;
const int mod=1e9+7;

int n, m;

vector<pii> edges[maxn];

struct Entry{
    int to, dist;
};

bool operator < (const Entry& l, const Entry& r){
    return l.dist > r.dist;
}

ll dist[maxn];
vector<int> curr_edges;

void get_distances(int x, int y){
    curr_edges.clear();

    for(int i=0; i<edges[x].size(); i++){
        if(edges[x][i].first<=y and edges[x][i].second>=y){
            curr_edges.pb(y - edges[x][i].first + 1);
        }

        if(edges[x][i].first>y) break;
    }

    return ;
}

int main(){

ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;

for(int i=0; i<m; i++){
    int a, l, r;
    cin>>a>>l>>r;

    edges[a].pb({l, r});
}

for(int i=1; i<=n; i++) sort(edges[i].begin(), edges[i].end());

for(int i=0; i<=n; i++) dist[i]=-1;

// start Dijkstra
dist[1]=0;
priority_queue<Entry> q;
q.push({1, 0});

while(!q.empty()){
    Entry curr_entry = q.top();
    q.pop();
    int curr=curr_entry.to;
    int curr_dist=curr_entry.dist;

    if(dist[curr]>curr_dist) continue;

    for(int i=1; i<=n; i++){
        if(i==curr) continue;

        get_distances(curr, i);

        for(auto w: curr_edges){
            if(dist[i]==-1 or dist[i]>curr_dist + w){
                dist[i]=curr_dist+w;
                q.push({i, dist[i]});
            }
        }
    }
}

for(int i=1; i<=n; i++){
    cout<<dist[i]<<" ";
}

return 0;
}

