/*
    Kak pravi bitkoina?
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const llong INF = 1e18;

int n, m;
std::vector <std::pair <int,int>> g[3 * MAXN];
int cnt;

struct SegmentTree
{
    int tree[4 * MAXN];
    void build(int l, int r, int node)
    {
        tree[node] = ++cnt;
        if (l == r)
        {
            g[tree[node]].push_back({l, 1});
            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node);
        build(mid + 1, r, 2*node + 1);
        g[tree[node]].push_back({tree[2*node], 0});
        g[tree[node]].push_back({tree[2*node + 1], mid - l + 1});
    }

    void update(int l, int r, int node, int queryL, int queryR, int queryNode)
    {
        if (queryL <= l && r <= queryR)
        {
            g[queryNode].push_back({tree[node], l - queryL});
            return;
        }

        int mid = l + r >> 1;
        if (queryL <= mid) update(l, mid, 2*node, queryL, queryR, queryNode);
        if (mid + 1 <= queryR) update(mid + 1, r, 2*node + 1, queryL, queryR, queryNode);
    }
};

bool vis[3 * MAXN];
llong dist[3 * MAXN];
SegmentTree tree;
void solve()
{
    std::priority_queue <std::pair <llong,int>> pq;
    std::fill(dist + 1, dist + cnt + 1, INF);
    pq.push({0, 1});
    dist[1] = 0;

    while (pq.size())
    {
        auto [d, node] = pq.top();
        pq.pop();

        if (vis[node])
        {
            continue;
        }

        vis[node] = true;
        for (const auto &[u, ed] : g[node])
        {
            if (dist[u] > dist[node] + ed)
            {
                dist[u] = dist[node] + ed;
                pq.push({-dist[u], u});
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (dist[i] == INF) dist[i] = -1;
        std::cout << dist[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> m;
    cnt = n;
    
    tree.build(1, n, 1);
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, l, r;
        std::cin >> u >> l >> r;
        tree.update(1, n, 1, l, r, u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}