/*
    Kak pravi bitkoina?
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const llong INF = 1e18;
const int MAXLOG = 17;

int n;
struct Fenwick
{
    int tree[MAXN];
    void update(int idx, int val)
    {
        for (; idx <= n + 1 ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }
    }

    int query(int idx)
    {
        int res = 0;
        for (; idx ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }

    int findKth(int k)
    {
        int idx = 0;
        for (int lg = MAXLOG - 1 ; lg >= 0 ; --lg)
        {
            if (idx + (1 << lg) <= n + 1 && tree[idx + (1 << lg)] < k)
            {
                idx += (1 << lg);
                k -= tree[idx];
            }
        }

        return idx + 1;
    }
};

std::vector <int> g[MAXN];
Fenwick tree;
llong ans;
llong add;

void dfs(int node)
{
    if (node == 1)
    {
        add += n;
        tree.update(node, 1);
    } else
    {
        int cnt = tree.query(node);
        int l = tree.findKth(cnt);
        int r = tree.findKth(cnt + 1);
        add += 1LL * (node - l) * (r - node);
        tree.update(node, 1);
    }

    ans += add;
    for (const int &u : g[node])
    {
        dfs(u);
    }

    tree.update(node, -1);
    if (node != 1)
    {
        int cnt = tree.query(node);
        int l = tree.findKth(cnt);
        int r = tree.findKth(cnt + 1);
        add -= 1LL * (node - l) * (r - node);
    }
}

void solve()
{
    tree.update(n + 1, 1);
    dfs(1);

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 2 ; i <= n ; ++i)
    {
        int p;
        std::cin >> p;
        g[p].push_back(i);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}