/*
    Kak pravi bitkoina?
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const int BUCKET_SIZE = 320;
const int BUCKET_COUNT = 320;
const llong INF = 1e18;
const int MAXLOG = 17;

int n, k;
int a[MAXN];
int b[MAXN];
bool isActive[MAXN];

struct Bucket
{
    int l, r;
    int cnt;
    llong sum[MAXN];

    void set()
    {
        std::fill(sum, sum + k, 0);
    }

    void rebuild()
    {
        int ptr = 0;
        cnt = 0;
        std::fill(sum, sum + k, 0);
        for (int i = l ; i <= r ; ++i)
        {
            if (isActive[i])
            {
                cnt++;
                ptr++;
                if (ptr == k) 
                {
                    ptr = 0;
                }

                sum[ptr] += b[i];
            }
        }
    }

    llong query(int reached)
    {
        int rem = k + 1 - (reached % k);
        if (rem >= k) rem -= k;
        return sum[rem];
    }
};

int perm[MAXN];
int inPerm[MAXN];
int inBucket[MAXN];
Bucket bucket[BUCKET_COUNT];

void solve()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return a[x] < a[y];
    });

    for (int i = 1 ; i <= n ; ++i)
    {
        inPerm[perm[i]] = i;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        b[inPerm[i]] = a[i];
    }

    int cntBuckets = 0;
    for (int i = 1 ; i <= n ; i += BUCKET_SIZE)
    {
        int l = i;
        int r = std::min(n, i + BUCKET_SIZE - 1);
        cntBuckets++;

        bucket[cntBuckets].l = l;
        bucket[cntBuckets].r = r;
        bucket[cntBuckets].cnt = 0;
        bucket[cntBuckets].set();
        for (int j = l ; j <= r ; ++j)
        {
            inBucket[j] = cntBuckets;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        isActive[inPerm[i]] = true;
        bucket[inBucket[inPerm[i]]].rebuild();

        int pos = 0;
        llong ans = 0;
        for (int j = 1 ; j <= cntBuckets ; ++j)
        {
            ans += bucket[j].query(pos);
            pos += bucket[j].cnt;
        }

        std::cout << ans << '\n';
    }
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}