#include<bits/stdc++.h>
#define MAXN 1000007
using namespace std;

const long long inf=1e17;

int n,m,a,l,r;
vector< pair<int,int> > v[MAXN];

void build(int w,int l,int r){
    if(l==r){
        v[w].push_back({4*n+l,1});
        return;
    }

    int tt=(l+r)/2;
    
    v[w].push_back({2*w,0});
    v[w].push_back({2*w+1,(tt-l+1)});

    build(2*w,l,tt);
    build(2*w+1,tt+1,r);
}

int update(int w,int l,int r,int ll,int rr,int root,int edge){
    if(ll>rr)return 0;

    if(l==ll and r==rr){
        v[root].push_back({w,edge});
        return r-l+1;
    }

    int tt=(l+r)/2;
    int sz=update(2*w,l,tt,ll,min(tt,rr),root,edge);
    sz+=update(2*w+1,tt+1,r,max(tt+1,ll),rr,root,edge+sz);

    return sz;
}

long long dist[MAXN];
bool vis[MAXN];

priority_queue< pair<long long,int> , vector< pair<long long,int> > , greater < pair<long long,int> > > q; 

void dijkstra(int x){
    for(int i=1;i<=5*n;i++)dist[i]=inf;

    dist[x]=0;
    q.push({0,x});

    while(!q.empty()){
        int minv=q.top().second;
        q.pop();

        if(vis[minv])continue;
        vis[minv]=true;

        for(auto e:v[minv]){
            if(vis[e.first] or dist[e.first]<=dist[minv]+e.second)continue;
            dist[e.first]=dist[minv]+e.second;
            q.push({dist[e.first],e.first});
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    build(1,1,n);

    for(int i=1;i<=m;i++){
        cin>>a>>l>>r;

        update(1,1,n,l,r,a+4*n,0);
    }

    dijkstra(4*n+1);

    for(int i=1;i<=n;i++){
        if(dist[4*n+i]==inf)cout<<"-1 ";
        else cout<<dist[4*n+i]<<" ";
    }
    cout<<"\n";

    return 0;
}