#include <iostream>
#include <vector>
#include <queue>
#include <limits>

using namespace std;
const int INF = numeric_limits<int>:: max();

struct Edge{
    int to,weight;
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N, M;
    cin >> N>> M;
    vector<vector<Edge>> graph(N+1);

    for(int i = 0 ; i<M; i++){
        int l, r, t;
        cin>>l>>r>>t;
        for(int u = l; u<=r; u++){
            graph[u].push_back({u+1, t});
        }
    }

    vector<int> dist(N+1,INF);
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> pq;
    dist[1] = 0;
    pq.push({0,1});
    while (!pq.empty()) {
        auto[d, u] = pq.top();
        pq.pop();

        if(d>dist[u]) continue;

        for(auto edge : graph[u]) {
            int v = edge.to, weight=edge.weight;
            if(dist[u]+ weight <dist[v]) {
                dist [v] = dist [u]+ weight;
                pq.push({dist[v],v});
            }
        }
    }

    for(int i = 1; i<=N; i++) {
        cout << (dist[i]== INF ? -1: dist[i]) <<" ";
    }
    cout<<endl;

    return 0;
}
