#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 4050;
const int64_t INF = 1e18;

class Graph
{
private:
    struct Edge
    {
        int to;
        int64_t weight;
        Edge(){}
        Edge(int to, int64_t weight)
            :to(to), weight(weight){}

        friend bool operator< (const Edge& a, const Edge& b)
        {
            return (a.weight > b.weight);
        }
    };
    int N;
    vector <Edge> graph[MAXN];
public:
    int64_t dist[MAXN];
    Graph(int N)
    {
        this->N = N;
        for (int i = 1; i <= N; i++)
        {
            dist[i] = INF;
        }
    }

    void AddEdge(int u, int v, int64_t weight)
    {
        graph[u].emplace_back(v, weight);
    }

    void Dijikstra(int startNode)
    {

        priority_queue <Edge> *pq = new priority_queue <Edge>();

        dist[startNode] = 0;
        pq->emplace(startNode, dist[startNode]);

        while (!pq->empty())
        {
            auto [currNode, currDist] = pq->top();
            pq->pop();

            if (dist[currNode] != currDist)
                continue;

            for (auto [nextNode, nextWeight]:graph[currNode])
            {
                if (dist[nextNode] < dist[currNode] + nextWeight)
                    continue;

                dist[nextNode] = dist[currNode] + nextWeight;
                pq->emplace(nextNode, dist[nextNode]);
            }
        }

        delete pq;
    }

    void PrintDistances(int startNode)
    {
        for (int i = 1; i <= N; i++)
        {
            cout << (dist[i]==INF?-1:dist[i]) << " ";
        }
        cout << endl;
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;

    Graph *graph = new Graph(N);

    graph->dist[1] = 0;
    for (int i = 0; i < M; i++)
    {
        int u, l, r;
        cin >> u >> l >> r;

        for (int v = l; v <= r; v++)
        {
            int64_t w = v-l+1;
            if (graph->dist[v] > graph->dist[u] + w)
            {
                graph->dist[v] = graph->dist[u] + w;
            }
        }
    }

    graph->PrintDistances(1);

    return 0;
}
