#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 505;
const int64_t INF = 1e18;

class Tree
{
private:
    int N;
    int parent[MAXN];
    vector <int> children[MAXN];
public:
    Tree(int N)
    {
        this->N = N;
        memset(parent, -1, sizeof(parent));
    }

    void AddEdge(int p, int c)
    {
        parent[c] = p;
        children[p].push_back(c);
    }

    int64_t AnswerFixedLeft(int l)
    {
        bool used[MAXN];
        memset(used, false, sizeof(used));
        int64_t ans = 0, currSize = 0;
        for (int r = l; r <= N; r++)
        {
            currSize = Query(l, r, currSize, used);
            ans += currSize;
        }

        return ans;
    }
    int64_t Query(int l, int r, int64_t currSize, bool *used)
    {
        for (int i = l; i <= r; i++)
        {
            if (used[i] == true)
                continue;

            this->DFS(i, currSize, used);
        }

        //cout << l << " " << r << " -> " << currSize << endl;
        return currSize;
    }

    void DFS(int currNode, int64_t &currSize, bool *used)
    {
        used[currNode] = true;
        currSize++;

        for (int child:children[currNode])
        {
            if (used[child])
                continue;

            this->DFS(child, currSize, used);
        }
    }

};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N;
    cin >> N;

    Tree *tree = new Tree(N);

    for (int i = 2; i <= N; i++)
    {
        int parent;
        cin >> parent;

        tree->AddEdge(parent, i);
    }

    int64_t ans = 0;
    for (int i = 1; i <= N; i++)
    {
        ans += tree->AnswerFixedLeft(i);
    }

    cout << ans << endl;

    return 0;
}
