#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5+50;
const int64_t INF = 1e18;

class Tree
{
private:
    int N;
    int parent[MAXN];
    vector <int> children[MAXN];
    vector <int> parentList[MAXN];
public:
    Tree(int N)
    {
        this->N = N;
        memset(parent, -1, sizeof(parent));
    }

    void AddEdge(int p, int c)
    {
        parent[c] = p;
        children[p].push_back(c);
    }

    void FillParentList()
    {
        for (int node = 1; node <= N; node++)
        {
            int x = node;
            while (parent[x] != -1)
            {
                x = parent[x];
                parentList[node].push_back(x);
            }
        }
    }

    int64_t Answer(int node)
    {
        int64_t ans = (node)*(N-node+1);
        for (int i: parentList[node])
        {
            //cout << i << " " << node << endl;
            ans += (i)*(N-i+1);
            if (node > i)
            {
                ans -= (N-node+1)*i;
            }
            else
            {
                ans -= (N-i+1)*node;
            }
        }

        return ans;
    }

};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N;
    cin >> N;

    Tree *tree = new Tree(N);

    for (int i = 2; i <= N; i++)
    {
        int parent;
        cin >> parent;

        tree->AddEdge(parent, i);
    }

    tree->FillParentList();

    int64_t ans = 0;
    for (int i = 1; i <= N; i++)
    {
        ans += tree->Answer(i);
    }

    cout << ans << endl;


    return 0;
}
