#include <bits/stdc++.h>
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct edge
{
    int ver,dist;
    edge(){};
    edge(int ve,int di)
    {
        ver=ve;
        dist=di;
    }
    bool operator < (const edge & e)const
    {
        return dist>e.dist;
    }
};

const int maxn=4005;
int n,m,d[maxn],inf=1e9;
vector<edge>v[maxn];
map<pair<int,int>,int>w;

void init()
{
    for(int i=1;i<=n;i++)d[i]=inf;
    d[1]=0;
}

void dijkstra()
{
    priority_queue<edge>q;
    edge node(1,0);
    q.push(node);
    while(!q.empty())
    {
        node=q.top();
        q.pop();
        for(edge nb : v[node.ver])
        {
            if(d[nb.ver]>d[node.ver]+nb.dist)
            {
                d[nb.ver]=d[node.ver]+nb.dist;
                q.push(nb);
            }
        }
    }
}

void read()
{
    cin>>n>>m;
    int u,l,r;
    for(int i=1;i<=m;i++)
    {
        cin>>u>>l>>r;
        for(int j=l;j<=r;j++)
        {
            if(w[{u,j}]==0)w[{u,j}]=j-l+1;
            else w[{u,j}]=min(w[{u,j}],j-l+1);
        }
    }

    for(map<pair<int,int>,int>::iterator it = w.begin();it!=w.end();it++)
    {
        v[(it->first).first].push_back({(it->first).second,(it->second)});
    }

    init();
    dijkstra();

    for(int i=1;i<=n;i++)
    {
        if(d[i]==inf)cout<<-1<<' ';
        else cout<<d[i]<<' ';
    }
    cout<<endl;
}

int main()
{
    speed();
    read();
    return 0;
}
