#include <iostream>
#include <queue>
#define endl '\n'
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
}

struct edge
{
    int to;
    int weight;

    edge(int _to, int _weight)
    {
        to = _to;
        weight = _weight;
    }

    edge()
    {
        to = 0;
        weight = 0;
    }

    bool operator < (const edge &e)const
    {
        return (weight > e.weight);
    }
};

const int MAXN = (int)1e5 + 5;

vector < edge > v[MAXN];
int dist[MAXN];
int n, m;

void read()
{
    cin >> n >> m;

    int l, r, u;

    for(int i = 1; i <= m ; i++)
    {
        cin >> u >> l >> r;

        for(int v1 = l ; v1 <= r ; v1++)
        {
            v[u].push_back({v1, (v1 - l + 1)});
        }
    }
}

void init()
{
    for(int i = 1 ; i <= n ; i++)
    {
        dist[i] = 1e9;
    }
}

void dijksta(int start)
{
    priority_queue < edge > pq;
    init();
    pq.push({start, 0});
    dist[start] = 0;
    while(!pq.empty())
    {
        edge node = pq.top();
        pq.pop();
        for(edge nb : v[node.to])
        {
            if(dist[nb.to] > dist[node.to] + nb.weight)
            {
                dist[nb.to] = dist[node.to] + nb.weight;
                pq.push({nb.to, dist[nb.to]});
            }
        }
    }
}

int main()
{
    speed();

    read();

    dijksta(1);

    for(int i = 1 ; i <= n ; i++)
    {
        if(dist[i] == 1e9)
            cout << -1 << ' ';
        else
            cout << dist[i] << ' ';
    }
    
    return 0;
}
