#include<bits/stdc++.h>
using namespace std;

struct input
{
    int u,l,r;
    input(){}
    input(int _u,int _l,int _r)
    {
        u=_u;
        l=_l;
        r=_r;
    }
};

struct edge
{
    int x,d;
    edge(){}
    edge(int _x,int _d)
    {
        x=_x;
        d=_d;
    }

    bool operator<(const edge&e)const
    {
        return e.d<d;
    }
};

int n,m;
input e[1000001];
vector<edge> v[1000001];

void build(int i,int l,int r)
{
    //cout<<i<<" - "<<l<<" "<<r<<endl;
    if(l==r)
    {
        v[i+n].push_back({l,l+1});
        return;
    }

    int md=(l+r)/2;
    build(i*2,l,md);
    build(i*2+1,md+1,r);

    v[i+n].push_back({i*2+n,0});
    v[i+n].push_back({i*2+1+n,0});
}

void query(int i,int l,int r,int ql,int qr,int id,int vl)
{
    if(ql>qr)return;
    if(ql<=l&&r<=qr)
    {
        v[id].push_back({i+n,vl});
        return;
    }

    int md=(l+r)/2;
    query(i*2,l,md,ql,min(qr,md),id,vl);
    query(i*2+1,md+1,r,max(md+1,ql),qr,id,vl);
}

void read()
{
    cin>>n>>m;
    build(1,1,n);
    for(int i=1;i<=m;i++)
    {
        cin>>e[i].u>>e[i].l>>e[i].r;
        query(1,1,n,e[i].l,e[i].r,e[i].u,-e[i].l);
    }
}

int d[1000001];

void dijkstra()
{
    for(int i=1;i<=5*n;i++)
        d[i]=1e9;
    priority_queue<edge> q;
    q.push({1,0});
    d[1]=0;

    while(q.size())
    {
        edge t=q.top();
        q.pop();
        //cout<<t.x<<" ! "<<t.d<<endl;

        if(d[t.x]>=t.d)
        {
            for(int i=0;i<v[t.x].size();i++)
            {
                edge nb=v[t.x][i];
                if(d[nb.x]>d[t.x]+nb.d)
                {
                    nb.d=d[t.x]+nb.d;
                    //cout<<nb.x<<" "<<nb.d<<endl;
                    d[nb.x]=nb.d;
                    q.push(nb);
                }
            }
        }
    }

    for(int i=1;i<=n;i++)
        if(d[i]==1e9)cout<<-1<<" ";
        else cout<<d[i]<<" ";
    cout<<'\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    dijkstra();
    return 0;
}
