#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 1e5 + 10;

struct Edge
{
    int u, bound;
    ll w;

    Edge(int _u = 0, ll _w = 0, int _bound = 0)
    {
        u = _u;
        w = _w;
        bound = _bound;
    }

    bool operator < (const Edge&e) const
    {
        return w > e.w;
    }
};

int n, m;
vector < pair < int, int > > adj[MAXN];

void input()
{
    cin >> n >> m;
    for (int j = 0; j < m; j ++)
    {
        int v, l, r;
        cin >> v >> l >> r;
        adj[v].push_back({l, r});
    }

}

const ll INF = 1e18;

int used[MAXN];
ll dist[MAXN];
void dijkstra()
{
    for (int i = 1; i <= n; i ++)
    {
        dist[i] = INF;
    }

    priority_queue < Edge > pq;
    pq.push(Edge(1, 0, 1));
    dist[1] = 0;

    while(!pq.empty())
    {
        Edge cur = pq.top();
        pq.pop();
        //cout << "step " << cur.u << " " << cur.w << " " << cur.bound << endl;

        if (cur.bound > cur.u)
        {
            Edge to = cur;
            to.u ++;
            to.w ++;
            if (dist[to.u] > to.w)
                dist[to.u] = to.w;
            pq.push(to);

        }

        if (used[cur.u])
            continue;

        used[cur.u] = 1;


        for (pair < int, int > moveTo : adj[cur.u])
        {
            Edge to = cur;
            to.u = moveTo.first;
            to.bound = moveTo.second;
            to.w ++;

            if (dist[to.u] > to.w)
                dist[to.u] = to.w;
            pq.push(to);

        }
    }
}

void print()
{
    for (int i = 1; i <= n; i ++)
    {
        if (used[i])
            cout << dist[i] << " ";
        else
            cout << -1 << " ";
    }
    cout << endl;
}
void solve()
{
    input();
    dijkstra();
    print();

}

int main()
{
    speed();
    solve();
    return 0;
}
