#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 1e5 + 10;

struct Edge
{
    int u, bound;
    ll w;

    Edge(int _u = 0, ll _w = 0, int _bound = 0)
    {
        u = _u;
        w = _w;
        bound = _bound;
    }

    bool operator < (const Edge&e) const
    {
        return w > e.w;
    }
};

int n, m;
vector < pair < int, int > > adj[MAXN];

void input()
{
    cin >> n >> m;
    for (int j = 0; j < m; j ++)
    {
        int v, l, r;
        cin >> v >> l >> r;
        adj[v].push_back({l, r});
    }

}

const ll INF = 1e18;

int used[MAXN];
ll dist[MAXN];
int par[MAXN];

int find_leader(int v)
{
    if (v == par[v])
        return v;
    return (par[v] = find_leader(par[v]));
}

void unite(int v, int u)
{
    v = find_leader(v);
    u = find_leader(u);
    assert(v != u);
    if (v > u)
        swap(v, u);
    par[v] = u;
}

void dijkstra()
{
    for (int i = 1; i <= n; i ++)
    {
        par[i] = i;
        dist[i] = INF;
    }

    priority_queue < Edge > pq;
    pq.push(Edge(1, 0, 1));
    dist[1] = 0;

    while(!pq.empty())
    {
        Edge cur = pq.top();
        pq.pop();
        //cout << "step " << cur.u << " " << cur.w << " " << cur.bound << endl;


        Edge to = cur;
        int mv = find_leader(to.u) + 1;
        to.u = mv;
        to.w += mv - cur.u;
        if (to.u <= cur.bound)
        {
            if (dist[to.u] > to.w)
                dist[to.u] = to.w;
            pq.push(to);
        }


        if (used[cur.u])
            continue;

        used[cur.u] = 1;
        if (used[cur.u + 1] == 1)
            unite(cur.u, cur.u + 1);
        if (used[cur.u - 1] == 1)
            unite(cur.u, cur.u - 1);

        for (pair < int, int > moveTo : adj[cur.u])
        {
            to = cur;
            to.u = moveTo.first;
            to.bound = moveTo.second;
            to.w ++;

            if (dist[to.u] > to.w)
                dist[to.u] = to.w;
            pq.push(to);

        }
    }
}

void print()
{
    for (int i = 1; i <= n; i ++)
    {
        if (used[i])
            cout << dist[i] << " ";
        else
            cout << -1 << " ";
    }
    cout << endl;
}
void solve()
{
    input();
    dijkstra();
    print();

}

int main()
{
    speed();
    solve();
    return 0;
}
