#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

mt19937 rng;

struct Treap
{
    struct Node
    {
        int key, val, pr;
        ll sum;
        int sz;

        Node *lf, *rf;

        Node(int _key, int _val)
        {
            key = _key;
            val = _val;
            pr = rng();
            sum = (ll)(val);
            sz = 1;
            lf = rf = nullptr;
        }

        void con()
        {
            sz = 1;
            sum = (ll)(val);
            if (lf != nullptr)
            {
                sz += lf -> sz;
                sum += lf -> sum;
            }

            if (rf != nullptr)
            {
                sz += rf -> sz;
                sum += rf -> sum;
            }
        }

        void trav()
        {
            if (lf) lf -> trav();
            cout << val << " ";
            if (rf) rf -> trav();
        }

        void print()
        {
            trav();
            cout << endl;
        }
    };

    Node *root = nullptr;

    void SplitKey(Node *T, Node *&L, Node *&R, int splitter)
    {
        if (T == nullptr)
        {
            L = nullptr;
            R = nullptr;
            return;
        }

        if (T -> key <= splitter)
        {
            L = T;
            SplitKey(T -> rf, L -> rf, R, splitter);
        }
        else
        {
            R = T;
            SplitKey(T -> lf, L, R -> lf, splitter);
        }

        T -> con();

    }

    void Merge(Node *&T, Node *L, Node *R)
    {
        if (L == nullptr)
        {
            T = R;
            return;
        }
        if (R == nullptr)
        {
            T = L;
            return;
        }

        if (L -> pr > R -> pr)
        {
            T = L;
            Merge(T -> rf, L -> rf, R);
        }
        else
        {
            T = R;
            Merge(T -> lf, L, R -> lf);
        }

        T -> con();
    }

    int get_size()
    {
        if (root == nullptr)
            return 0;
        return root -> sz;
    }

    Node *split_treap(int pos)
    {
        Node *L, *R;
        SplitKey(root, L, R, pos);
        root = L;
        return R;
    }

    void attach_element(int key, int val)
    {
        Node *el = new Node(key, val);
        Merge(root, root, el);
    }

    void attach_treap(Node *add)
    {
        Merge(root, root, add);
    }

    ll get_sum()
    {
        if (root == nullptr)
            return 0;
        return root -> sum;
    }

};

const int MAXN = 1e5 + 10;
Treap arr[MAXN], sp[MAXN];

int a[MAXN], rev[MAXN], n, k;

int fen[MAXN];
void update(int pos, int val)
{
    for (int i = pos; i <= n; i += (i & -i))
        fen[i] += val;
}
int sum(int pos)
{
    int s = 0;
    for (int i = pos; i > 0; i -= (i & -i))
        s += fen[i];
    return s;
}

vector < pair < int, int > > vec;
void rebuild(int to)
{
    for (int i = 0; i < k; i ++)
    {
        arr[i].root = nullptr;
    }

    int br = 0;
    for (int i = 0; i < n; i ++)
    {
        if (vec[i].second > to)
            continue;
        arr[br].attach_element(i, vec[i].first);
        br ++;
        br %= k;
    }
}

void solve()
{
    /**Treap test;
    test.attach_element(3, 5);
    test.attach_element(5, 10);
    test.attach_element(7, 8);
    test.split_treap(5) -> print();
    test.root -> print();
    return;*/
    cin >> n >> k;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        vec.push_back({a[i], i});
    }

    sort(vec.begin(), vec.end());
    for (int i = 0; i < n; i ++)
        rev[vec[i].second] = i;

    int cap = n + 2;
    for (int i = 1; i <= n; i ++)
    {
        if (i % max(1, (cap - 1)) == 0)
        {
            rebuild(i - 1);
            /**cout << "rebuild" << endl;
            for (int j = 0; j < k; j ++)
            {
                if (arr[j].root != nullptr)
                arr[j].root -> print();
                else
                    cout << endl;
            }
            cout << "done" << endl;*/
        }
        int pos = rev[i];
        //cout << "POS " << pos << endl;
        int bef = sum(pos + 1);
        //cout << "bef " << bef << endl;
        update(pos + 1, 1);

        for (int j = max(k - cap, 0); j < k; j ++)
        {
            sp[j].root = arr[j].split_treap(pos);
        }
        if (k - cap > 0)
        {
            //cout << "special " << pos << endl;
            sp[0].root = arr[0].split_treap(pos);
            /**if (arr[0].root != nullptr)
            {
                arr[0].root -> print();
            }*/
        }
        ///cout << "bef " << bef << endl;
        bef = bef % k;
      /**cout << "after move" << endl;
                    for (int j = 0; j < k; j ++)
            {
                if (arr[j].root != nullptr)
                arr[j].root -> print();
                else
                    cout << endl;
            }*/

        arr[bef].attach_element(pos, a[i]);

        for (int j = max(k - cap, 0); j < k; j ++)
        {
            int to = (j + 1) % k;
            arr[to].attach_treap(sp[j].root);
        }

        cout << arr[0].get_sum() << endl;
    }
}

int main()
{
    speed();
    solve();
    return 0;
}
