#include <iostream>
#include <vector>
#include <queue>
#include <limits>
using namespace std;
const int INF =
numeric_limits<int>: : max();
const int MAX_N = 1000000;
vector<pair<int, int>> adj[ MAX_N + 1 ];
int dist[ MAX_N + 1 ];
void dijkstra(int start, int n) {
	priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;

	fill(dist + n + 1, INF);
	dist[start] = 0;
	pq.push({ 0, start });

	while (!pq.empty()) {
		int d = pq.top().first;
		int u = pq.top().second;
		pq.pop();

		if (d > dist[u]) continue;

		for (auto& [v, w] : adj[u]) {
			if (dist[u] + w < dist[v]) {
				dist[v] = dist[u] + w;
				pq.push({ dist[v], v });

			}
		}
	}

}
int main() {
ios: :sync_with_studio(false);
	cin.tie(nullptr);

	for (int i = 0; i < M; i++) {
		int u, l, r;
		cin >> u >> l >> r;
		for (int v = 1; v <= r; v++) {
			int w = v - 1 + 1;
			adj[u].push_back({ v, w });
		}
	}

	dijkstra(1, N);

	for (int i = 1; i <= N; i++) {
		if (dist[i] == INF)
			cout << -1 << " ";

	}
	return 0;
}