#include <queue>
#include <vector>
#include <iostream>
#include <algorithm>
#include <set>
#include<unordered_set>
typedef long long ll;
using namespace std;

struct edge {
	int u, v;
	ll weight;
};

const int maxn = 1 + 1e5, INF = 1e9;
set<pair<int, int>> edges[maxn];
int dist[maxn];

void dijkstra(int start = 1) {
	fill_n(dist, maxn, INF);
	dist[start] = 0;
	priority_queue < pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
	pq.push({ 0,start });

	while (!pq.empty()) {
		auto [curr_dist, u] = pq.top();
		pq.pop();

		for (auto [v, w] : edges[u]) {
			if (dist[u] != INF && dist[v] > dist[u] + w)
			{
				dist[v] = dist[u] + w;
				pq.push({ dist[v],v });
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m;
	cin >> n >> m;

	vector <pair<int,int>> a(n, {INF,-INF});
	for (int i = 0; i < m;i++) {
		int u, l, r;
		cin >> u >> l >> r;

		if (a[u].first == INF || a[u].second == -INF) {
			for (int v = l; v <= r;v++)
				if (u != v)
					edges[u].insert({ v,v - l + 1 });
			continue;
		}
				

		if(a[u].first > l)
		for (int v = l; v < a[u].first;v++)
			if (u != v) 
				edges[u].insert({ v,v - l + 1 });
			

		if(a[u].second < r)
		for (int v = a[u].second+1; v <= r;v++)
			if (u != v) 
				edges[u].insert({ v,v - l + 1 });
			

		a[u] = { min(a[u].first,l),max(a[u].second,r) };
	}

	dijkstra();

	for (int i = 1; i <= n;i++)
		cout << (dist[i] == INF ? -1 : dist[i]) << " ";
	cout << endl;
}
