#include <queue>
#include <vector>
#include <iostream>
#include <algorithm>
#include <set>
typedef long long ll;
using namespace std;

struct edge {
	int u, v;
	ll weight;
};

const int maxn = 1 + 1e5, INF = 1e9;
vector<pair<int, int>> edges[maxn];
int rebra[4001][4001];
int dist[maxn];

void dijkstra(int start = 1) {
	fill_n(dist, maxn, INF);
	dist[start] = 0;
	priority_queue < pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
	pq.push({ 0,start });

	while (!pq.empty()) {
		auto [curr_dist, u] = pq.top();
		pq.pop();

		for (auto &[v, w] : edges[u]) {
			if (dist[u] != INF && dist[v] > dist[u] + w)
			{
				dist[v] = dist[u] + w;
				pq.push({ dist[v],v });
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m;i++) {
		int u, l, r;
		cin >> u >> l >> r;
		for (int v = l; v <= r;v++) {
			if (rebra[u][v] > (v-l+1)){
				edges[u].push_back({ v,v - l + 1 });
				rebra[u][v] = v-l+1;
			}
		}
	}
	dijkstra();

	for (int i = 1; i <= n;i++)
		cout << (dist[i] == INF ? -1 : dist[i]) << " ";
	cout << endl;
}