#include <queue>
#include <vector>
#include <iostream>
#include <algorithm>
#include <set>
typedef long long ll;
using namespace std;

struct edge {
	int u, v;
	ll weight;
};

const int maxn = 1 + 1e5, INF = 1e9;
vector<pair<int, int>> edges[maxn];
ll dist[maxn];
ll rebra[4001][4001];

void dijkstra(int start = 1) {
	fill_n(dist, maxn, INF);
	dist[start] = 0;
	priority_queue < pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
	pq.push({ 0,start });

	while (!pq.empty()) {
		auto [curr_dist, u] = pq.top();
		pq.pop();

		for(int i=0; i<4001;i++)
			if (rebra[u][i] != INF) {
				ll w = rebra[u][i];
				if (dist[i] > dist[u] + w)
				{
					dist[i] = dist[u] + w;
					pq.push({ dist[i], i });
				}
			}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m;
	cin >> n >> m;

	fill_n(&rebra[0][0], 4001 * 4001, INF);
	for (int i = 0; i < m;i++) {
		int u, l, r;
		cin >> u >> l >> r;
		for (int v = l; v <= r;v++) 
			rebra[u][v] = min(rebra[u][v], (ll)v - l + 1);
	}
	dijkstra();

	for (int i = 1; i <= n;i++)
		cout << (dist[i] == INF ? -1 : dist[i]) << " ";
	cout << endl;
}