#include <queue>
#include <vector>
#include <iostream>
#include <algorithm>
#include <set>
typedef long long ll;
using namespace std;

const int maxv = 1 + 1e5;
vector<int> child[maxv];
bool marked[maxv];

int dfs2(int start) {
	int ans = 1;
	for (int next : child[start])
		ans += dfs2(next);
	return ans;
}

int dfs(int start) {
	int ans = 0;
	if (marked[start]) {
		ans = 1;
		for (int next : child[start])
			ans += dfs2(next);
	}
	else {
		for (int next : child[start])
			ans += dfs(next);
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n,x;
	cin >> n;

	for (int i = 2; i <= n;i++) {
		cin >> x;
		child[x].push_back(i);
	}
	
	int ans = 0;
	for(int i=1; i<=n;i++)
		for (int j = i; j <= n;j++) {
			fill_n(marked, maxv, false);
			for (int k = i;k<=j;k++)
				marked[k] = true;
			ans += dfs(1);
		}

	cout << ans << endl;

}